//------------------------------------------------------------------
// SSE2033: System Software Experiment 2 (Spring 2016)
//
// Skeleton code for PA #2
// May 11, 2016
//
// Dong-Yun Lee
// Computer Systems Laboratory
// Sungkyunkwan University

//------------------------------------------------------------------

#include "main.h"

int main(int argc, char** argv) {
	int i;
	struct timeval start_t, end_t, result_t;
	int n_bible;

	if(argc < 2) {
		printf("Usage : %s [bible text files]\n", argv[0]);
		return 1;
	}

	n_bible = argc - 1;

	for(i=0;i<n_bible;i++) {
		set_name(argv[i+1], i);
	}
	
	/*************************************
	 * Index Builder
	 *************************************/
	printf("** Index Builder : Start\t**\n");
	gettimeofday(&start_t, NULL);

	for(i=0;i<n_bible;i++)
		indexBuilder(inputFileNm[i], indexFileNm[i]);

	gettimeofday(&end_t, NULL);
	timersub(&end_t, &start_t, &result_t);
	printf("   Elapsed Time  : %ld(usec)\n",
			100000*(result_t.tv_sec)+result_t.tv_usec);
	printf("** Index Builder : End\t\t**\n");
	
	printf("\n");

	return 0;
}

int valid_name(int index)
{
	return valid_check[index];
}

void set_name(char* name, int index)
{
	int i;
	for(i=0; name[i]!='.'; i++);

	inputFileNmLen[index] = i;
	inputFileNm[index] = (char *)malloc(sizeof(char)*inputFileNmLen[index]+1);

	for(i=0; i<inputFileNmLen[index]; i++)
		inputFileNm[index][i] = name[i];

	inputFileNm[index][i] = 0;

	indexFileNmLen[index] = inputFileNmLen[index] + 7;
	outputFileNmLen[index] = inputFileNmLen[index] + 8;

	// index file name
	indexFileNm[index] = (char *)malloc(sizeof(char)*indexFileNmLen[index]);
	sprintf(indexFileNm[index], "%s_index", inputFileNm[index]);
	
	// output file name
	outputFileNm[index] = (char *)malloc(sizeof(char)*outputFileNmLen[index]);
	sprintf(outputFileNm[index], "%s_output", inputFileNm[index]);
	
	valid_check[index] = 1;
}


void del_name(int index)
{
	inputFileNmLen[index] = 0;
	outputFileNmLen[index] = 0;
	indexFileNmLen[index] = 0;

	free(inputFileNm[index]);
	free(indexFileNm[index]);
	free(outputFileNm[index]);

	valid_check[index] = 0;
}
